"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isIgnoredPath = void 0;
// builtin
var path_1 = require("path");
// external
var ignorepatterns_1 = __importDefault(require("ignorepatterns"));
/** Tests the path against provided prefixes and regular expressions */
function matches(path, matches) {
    var e_1, _a;
    try {
        for (var matches_1 = __values(matches), matches_1_1 = matches_1.next(); !matches_1_1.done; matches_1_1 = matches_1.next()) {
            var match = matches_1_1.value;
            if (typeof match === 'string') {
                if (path.startsWith(match))
                    return true;
            }
            else if (match.test(path))
                return true;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (matches_1_1 && !matches_1_1.done && (_a = matches_1.return)) _a.call(matches_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return false;
}
/** Tests whether the path should be ignored */
function isIgnoredPath(path, opts) {
    var _a, _b, _c;
    if (opts === void 0) { opts = {
        ignoreCommonPatterns: true,
    }; }
    // handle deprecations
    opts = __assign(__assign({ ignoreHiddenBasenames: opts.ignoreHiddenFiles, ignoreUndesiredBasenames: opts.ignoreCommonPatterns }, opts), { ignoreAbsolutePaths: __spreadArray(__spreadArray([], __read((opts.ignoreAbsolutePaths || [])), false), __read((opts.ignorePaths || [])), false), ignoreRelativePaths: __spreadArray(__spreadArray([], __read((opts.ignoreRelativePaths || [])), false), __read((opts.ignorePaths || [])), false), ignoreBasenames: __spreadArray(__spreadArray([], __read((opts.ignoreBasenames || [])), false), __read((opts.ignorePaths || [])), false) });
    // extract path, fallback basename, and reconstruct path with its custom properties if any (helpful for scandirectory)
    var absolutePath = path.absolutePath, relativePath = path.relativePath;
    var basename = path.basename;
    if (!basename && (absolutePath || relativePath))
        basename = (0, path_1.basename)(absolutePath || relativePath || '');
    path = __assign(__assign({}, path), { basename: basename });
    // custom callback
    if (opts.ignoreCustomCallback && opts.ignoreCustomCallback(path) === true)
        return true;
    // absolute path checks
    if (absolutePath) {
        // match
        if (((_a = opts.ignoreAbsolutePaths) === null || _a === void 0 ? void 0 : _a.length) &&
            matches(absolutePath, opts.ignoreAbsolutePaths))
            return true;
        // custom?
        if (opts.ignoreCustomPatterns &&
            opts.ignoreCustomPatterns.test(absolutePath))
            return true;
    }
    // relative path checks
    if (relativePath) {
        // match
        if (((_b = opts.ignoreRelativePaths) === null || _b === void 0 ? void 0 : _b.length) &&
            matches(relativePath, opts.ignoreRelativePaths))
            return true;
        // custom?
        if (opts.ignoreCustomPatterns &&
            opts.ignoreCustomPatterns.test(relativePath))
            return true;
    }
    // basename checks
    if (basename) {
        // match
        if (((_c = opts.ignoreBasenames) === null || _c === void 0 ? void 0 : _c.length) && matches(basename, opts.ignoreBasenames))
            return true;
        // hidden?
        if (opts.ignoreHiddenBasenames && basename[0] === '.')
            return true;
        // common?
        if (opts.ignoreUndesiredBasenames &&
            ignorepatterns_1.default.test(basename))
            return true;
        // custom?
        if (opts.ignoreCustomPatterns && opts.ignoreCustomPatterns.test(basename))
            return true;
    }
    // not ignored
    return false;
}
exports.isIgnoredPath = isIgnoredPath;
/** Compatibility wrapper for {@link isIgnoredPath} */
function isIgnoredPathCompatibility(path, opts) {
    if (typeof path === 'string') {
        var result = {};
        if ((0, path_1.isAbsolute)(path))
            result.absolutePath = path;
        else
            result.relativePath = path;
        result.basename = (0, path_1.basename)(path);
        return isIgnoredPath(result, opts);
    }
    else {
        return isIgnoredPath(path, opts);
    }
}
exports.default = isIgnoredPathCompatibility;
